#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

struct ii {
    int x,y;
};

ii line[110];
int n;

double intxp(int y, int l)
{
    if((y<line[l].y || y>line[l+1].y) && (y>line[l].y || y<line[l+1].y))
        return 1.0/0.0;

    if(line[l].y == line[l+1].y)
        return 1.0/0.0;

    double xx = line[l].x + double(line[l+1].x - line[l].x)/double(line[l].y - line[l+1].y) *
        (line[l].y - y);

    return xx;
}

double intyp(int x, int l)
{
    if((x<line[l].x || x>line[l+1].x) && (x>line[l].x || x<line[l+1].x))
        return 1.0/0.0;

    if(line[l].x == line[l+1].x)
        return 1.0/0.0;

    double yy = line[l].y + double(line[l+1].y - line[l].y)/double(line[l].x - line[l+1].x) *
        (line[l].x - x);

    return yy;
}

bool intx(int x, int y, int l)
{
    double xx = intxp(y, l);
    return xx-1e-9 >= x && xx+1e-9 <= x+1;
}

bool inty(int x, int y, int l)
{
    double yy = intyp(x, l);
    return yy-1e-9 >= y && yy+1e-9 <= y+1;
}

bool inside(int x, int y)
{
    int inter = 0;
    for(int i=1; i<n+1; ++i) {
        if(line[i+1].x==x)
            continue;
        if(line[i].x==x) {
            if((line[i-1].x<x) != (line[i+1].x<x))
                ++inter;
        } else {
            double yy = intyp(x, i);
            if(finite(yy) && yy-1e-9>=y)
                ++inter;
        }
    }

    return inter%2;
}

int main()
{
    ii mi,ma;
    mi.x=1000;
    mi.y=1000;
    ma.x=-1000;
    ma.y=-1000;

    while(cin>>n, n) {
        int res = 0;
        int adj = 0;
        for(int i=0; i<n+adj; ++i) {
            cin >> line[i].x >> line[i].y;
            mi.x=min(mi.x,line[i].x);
            mi.y=min(mi.y,line[i].y);
            ma.x=max(mi.x,line[i].x);
            ma.y=max(mi.y,line[i].y);
            if(i>=2 && line[i].x==line[i-1].x && line[i].x==line[i-2].x) {
                line[i-1] = line[i];
                --i;
                --n;
                ++adj;
            }
            if(i>=2 && line[i].y==line[i-1].y && line[i].y==line[i-2].y) {
                line[i-1] = line[i];
                --i;
                --n;
                ++adj;
            }
        }
        line[n] = line[0];
        line[n+1] = line[1];

        for(int i=mi.x; i<=ma.x; ++i) {
            for(int j=mi.y; j<=ma.y; ++j) {
                bool inters = false;
                for(int k=0; k<n; ++k) {
                    if(intx(i,j,k) or intx(i,j+1,k) or inty(i,j,k) or inty(i+1,j,k)) {
                        inters = true;
                        break;
                    }
                }

                if(!inters && inside(i,j) && inside(i+1,j) &&
                        inside(i,j+1) && inside(i+1,j+1))
                    ++res;
            }
        }

        cout << res << endl;
    }

    return 0;
}
