#include <cstring>
#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>

using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef set<ii> Set;

int v,e;

Set s;
vvi E;

char target[10010];
char cur[10010];
int prev[10010];

void flip(int a, int b)
{
    if(a>b)
        swap(a,b);

    Set::iterator i = s.find(ii(a,b));
    if(i!=s.end())
        s.erase(i);
    else
        s.insert(ii(a,b));
}

bool doit(int start)
{
    fill(prev, prev+v, -1);
    prev[start] = start;
    int finish;

    queue<int> q;
    q.push(start);
    while(! q.empty()) {
        int c = q.front();
        q.pop();

        for(vi::iterator i=E[c].begin(); i!=E[c].end(); ++i) {
            if(prev[*i] != -1)
                continue;

            prev[*i] = c;
            q.push(*i);

            if(target[*i]=='o' && cur[*i]!='o') {
                finish = *i;
                goto found;
            }
        }
    }
    return false;

found:
    cur[finish] = 'o';
    while(finish != start) {
        flip(finish, prev[finish]);
        finish = prev[finish];
    }
    cur[finish] = 'o';

    return true;
}

int main()
{
    while(cin>>v>>e, v||e) {
        E.clear();
        s.clear();
        strcpy(cur, string(v, 'e').c_str());
        E.insert(E.end(), v, vi());

        for(int i=0; i<e; ++i) {
            int a,b;
            cin >> a >> b;
            --a;
            --b;

            E[a].push_back(b);
            E[b].push_back(a);
        }

        cin >> target;

        bool done = false;
        while(not done) {
            int i;
            for(i=0; i<v; ++i) {
                if(target[i]=='o' && cur[i]!='o') {
                    if(not doit(i))
                        done = true;
                    break;
                }
            }
            if(i==v)
                done = true;
        }
        if(string(target) == string(cur)) {
            cout << s.size() << endl;
            for(Set::iterator i=s.begin(); i!=s.end(); ++i)
                cout << (i->first+1) << " " << (i->second+1) << endl;
        } else
            cout << "impossible\n";
    }

    return 0;
}
